//+------------------------------------------------------------------+
//|                                           FileAndStructIssue.mq5 |
//|                                   Copyright 2021, Alain Verleyen |
//|                     https://login.mql5.com/en/users/angevoyageur |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Alain Verleyen"
#property link      "https://login.mql5.com/en/users/angevoyageur"
#property version   "1.00"

struct Base
  {
   int               anInt;
   double            aDouble;
                     Base(void)
     {
      anInt   = WRONG_VALUE;
      aDouble = WRONG_VALUE;
     }
  };
struct DerivedNoNew : public Base
  {
   void              Set(int iValue,double dValue)
     {
      anInt   = iValue;
      aDouble = dValue;
     }
  };
struct DerivedWithNew : public Base
  {
   long              aLong;
   void              Set(int iValue,double dValue,long lValue)
     {
      anInt   = iValue;
      aDouble = dValue;
      aLong   = lValue;
     }
  };

const string filename = "TestStructToFile";
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   Base base[1];
   DerivedWithNew derivedWith[1];
   DerivedNoNew derived[1];
   int sizeof1   = sizeof(Base);
   int sizeof2   = sizeof(DerivedWithNew);
   int sizeof3   = sizeof(DerivedNoNew);
      printf("Sizeof Base: %i DerivedWithNew: %i DerivedNoNew: %i",sizeof1,sizeof2,sizeof3);

   int handle=FileOpen(filename,FILE_BIN|FILE_WRITE);
   if(handle!=INVALID_HANDLE)
     {
      derivedWith[0].Set(123,-M_PI,LONG_MAX);
      derived[0].Set(5,12.0);

      uint written1 = FileWriteStruct(handle,base[0],sizeof1);
      uint written2 = FileWriteStruct(handle,derivedWith[0],sizeof2);
      uint written3 = FileWriteStruct(handle,derived[0],sizeof3);
      int err       = _LastError;

      ArrayPrint(base);
      ArrayPrint(derived);
      ArrayPrint(derivedWith);
      printf("Written 1: %u 2: %u 3: %u (error %i) Total: %u FileSize: %u",written1,written2,written3,err,written1+written2+written3,FileSize(handle));
      FileClose(handle);
     }

   handle=FileOpen(filename,FILE_BIN|FILE_READ);
   if(handle!=INVALID_HANDLE)
     {
      uint read3  = FileReadStruct(handle,derived[0],sizeof3);
      int err     = _LastError;
      uint read1  = FileReadStruct(handle,base[0],sizeof1);
      uint read2  = FileReadStruct(handle,derivedWith[0],sizeof2);

      ArrayPrint(base);
      ArrayPrint(derived);
      ArrayPrint(derivedWith);
      printf("Read 1: %u 2: %u 3: %u (error %i) Total: %u",read1,read2,read3,err,read1+read2+read3);
      FileClose(handle);
     }


  }
//+------------------------------------------------------------------+
